function [ Orientation ] = function_CalculateFeatures_own(SSK_back, SSK,CurveDirection,PointStatus, endPoint )
%Choose a set of end points to simulate the curve end, and then fit the
%curve by a smooth function and calculate its curvature.
%   Detailed explanation goes here

NumberOfPointsOrientation = 20;       % how many points' orientations we shall recorded/remember

%% Orientation at the endpoint

LastPoint = [];
x=endPoint(1);
y=endPoint(2);
Beta = CurveDirection(x,y);

if sum(SSK(:))==1
    Orientation = 0;
else
    [x_n,y_n] = function_FindNextPoint(PointStatus,x,y,LastPoint);
    if ~SSK_back(x_n,y_n)
        LastPoint = [x_n,y_n];
        [x_n,y_n] = function_FindNextPoint(PointStatus,x,y,LastPoint);
    end
    n=1;
    if isempty(x_n)
        Orientation=0;
        disp('error when Calculating Features');
    else
        Ori(1) = function_InvertOrientation(x, y, x_n, y_n, Beta);
        for i = 2:NumberOfPointsOrientation
            LastPoint = [x,y];
            x=x_n;
            y=y_n;
            [x_n,y_n] = function_FindNextPoint(PointStatus,x,y,LastPoint);
            if isempty(x_n)
                break;
            end
            n = n + 1;
            Beta = CurveDirection(x,y);
            Ori(n) = function_InvertOrientation(x, y, x_n, y_n, Beta);
        end
        
        Ori(Ori<0)=2*pi-abs(Ori(Ori<0));
        Y=mean(sin(Ori));X=mean(cos(Ori));
        r=sqrt(X^2+Y^2);
        cosori=X/r;sinori=Y/r;
        meanOri=atan(sinori/cosori);
        
        if sinori>=0&&cosori>=0
            Orientation=abs(meanOri);
        elseif sinori>=0&&cosori<0
            Orientation=pi-abs(meanOri);
        elseif sinori<0&&cosori<0
            Orientation=pi+abs(meanOri);
        else
            Orientation=2*pi-abs(meanOri);
        end
        
        %Orientation = mean(Ori);
%         Ori(Ori<0)=2*pi-abs(Ori(Ori<0));
%         Ori=sort(Ori,'descend');
%         l=ceil(length(Ori)*0.4);
%         Orientation = mean(Ori(1:l));
%         for i=1:NumberOfPointsOrientation
%             if (Ori(i)<0)
%                 Ori()
%             end
%         end
    end
    
end
    

%% Curvature 
%Later Process: we can return a set of points, and then fit a curve
Curvature = 0;
%...
%...
end

