% This function is to determine the directions of the curve points 
% at given pixel (x,y) within a bw image.
%----------------------------------------------------------------------------------------------
% By Yu Weimiao @ BII, Oct. 2008;
%-------------------------------------------------------

function [Orientation] = function_CalculateOrientation (SKBW)

if (length(find(SKBW==1))>10)
 H = fspecial ('gaussian', [5 5], 2);
else
H = fspecial ('gaussian', [3 3], 2);
end

im_bw =imfilter(im2double(SKBW),H,'replicate');

dx_central = ( circshift( im_bw, [ 0, -1 ] ) - circshift( im_bw, [ 0, 1 ] ) ) / 2;

dy_central = ( circshift( im_bw, [ -1, 0 ] ) - circshift( im_bw, [ 1, 0 ] ) ) / 2;

dxdy_central = ( circshift( dx_central, [ -1, 0 ] ) - circshift( dx_central, [ 1, 0 ] ) ) / 2;

dydx_central = ( circshift( dy_central, [ 0, -1 ] ) - circshift( dy_central, [ 0, 1 ] ) ) / 2;

dxx_central=( circshift( dx_central, [ 0, -1 ] ) - circshift( dx_central, [ 0, 1 ] ) ) / 2;

dyy_central=( circshift( dy_central,  [ -1, 0 ]  ) - circshift(dy_central, [ 1, 0 ] ) ) / 2;

[x,y] = find(SKBW==1);

Orientation = zeros(size(SKBW));

for i =1:1:length(x)

    Hessian = [dxx_central(x(i),y(i)) dxdy_central(x(i),y(i));dydx_central(x(i),y(i)) dyy_central(x(i),y(i))];
    [V,D] = eig(Hessian);
    [Y] = max(abs(D));
    [a Ind] = max(Y);
    Vector = V(:,Ind);
    
    Beta = atan2(-Vector(2), Vector(1));

    Orientation(x(i),y(i))=Beta;
%     % display the orientation of the points
%     % figure(2);
%     figure(2);imagesc(SKBW);colormap gray;title('BW Image'); hold on;
%     x1 = x(i) +10.*cos(Beta);
%     y1 = y(i) +10.*sin(Beta);
%     plot([y1 y(i)],[x1 x(i)]);
%     % % %     plot(y1,x1,'r.');
%     plot([y(i) y1],[x(i) x1],'r-','MarkerSize',9);
%     A = 0;
end
